class Strongspace.Views.Settings extends Backbone.View

	initialize: ->
	
	events: ->
		"click #start_at_login": "toggleStartAtLogon"
		"click .togglePrefBool": "togglePrefBool"
		"click #ReleaseChannel": "toggleReleaseChannel"
		"click #ShowInDock": "toggleShowInDock"
		"click #check_for_updates": "checkForUpdates"
		"click #install_terminal_utility" : "installTerminalUtility"
		"click #enter_license_key" : "enterLicenseKey"
		"submit #license_form" : "activateKey"
		"click #send_to_store" : "sendToStore"

	afterRender: ->
		if loginitem.willLaunchAtLogon()
			$("#start_at_login").prop('checked', true)
		if settings.getBool("RevealAfterConnect")
			$("#RevealAfterConnect").prop('checked', true)
		if settings.getBool("ShowManagerAtLaunch")
			$("#ShowManagerAtLaunch").prop('checked', true)
		if settings.getBool("SUEnableAutomaticChecks")
			$("#SUEnableAutomaticChecks").prop('checked', true)
		if settings.getBool("ShowInDock")
			$("#ShowInDock").prop('checked', true)

		if settings.getBool("ShowDesktopNotifications")
			$("#ShowDesktopNotifications").prop('checked', true)
			
		if settings.getString("ReleaseChannel") == "beta"
			$("#ReleaseChannel").prop('checked', true)

		if settings.platform() != "mac"
			$(".platform_mac").remove()

	toggleStartAtLogon: (e) ->
		if $("#start_at_login").prop('checked') == true
			loginitem.setLaunchAtLogon(true)
		else
			loginitem.setLaunchAtLogon(false)

	togglePrefBool: (e) ->
		settings.setBool($(e.target).prop('checked'), $(e.target).attr('id'))
		return true

	toggleReleaseChannel: (e) ->
		if $("#ReleaseChannel").prop('checked') == true
			settings.setString("beta", "ReleaseChannel")
		else
			settings.setString("stable", "ReleaseChannel")

	toggleShowInDock: (e) ->
		if $("#ShowInDock").prop('checked') == true
			settings.setString(true, "ShowInDock")
			settings.showInDock(true)
		else
			settings.setString(false, "ShowInDock")
			settings.showInDock(false)

	checkForUpdates: (e) ->
		e.preventDefault()
		updater.checkForUpdates()

	installTerminalUtility: (e) ->
		e.preventDefault()
		settings.installTerminalUtility($('#terminal_utility_location').val())

	enterLicenseKey: (e) ->
		e.preventDefault()
		
		if $("#enter_license_key").html() == "Activate"
			$("#license_form").submit()
			return

		$("#license_key_text").show(200, ->
				this.focus()
			)

		$("#enter_license_key").html("Activate")
		$("#license_key_text").keyup( (event) ->
		    if(event.keyCode == 13)
		        $("#license_form").submit()
			)

	activateKey: (e) ->
		e.preventDefault()
		key = $("#license_key_text").val()
		$("#enter_license_key").html("Activating...").prop('disabled', true).blur()
		$("#license_key_text").prop('disabled', true).blur()
		
		$.ajax
			url: "https://secure.expandrive.com/store/order/license"
			type: "POST"

			data: 
				"serial" : $("#license_key_text").val()
				"previous_sha1" : license.licenseSHA1()
				
			success: (data) ->
				license.setLicenseString(data)
				Strongspace.Sidebar.render()
				Strongspace.Details.render()
				Strongspace.Settings.render()
				Strongspace.showSettings()

			error: (data) ->
				alert "Could not activate this license key."
				$("#enter_license_key").html("Activate").prop('disabled', false).blur()
				$("#license_key_text").prop('disabled', false).blur()


	sendToStore: (e) ->
		e.preventDefault()
		settings.sendToStore()

